//////////////////////////////////////////////////////////////////////////////
//                                                                          //
//                              //
//                                                                          //
//                                               //
//                                           //
//                                                                          //
//                          ftou32.asm                                      //
//                                                                          //
//        32          //
//       32 .                                //
// ConvFtoU32 -  float     .                  //        
//                                                                          //
//////////////////////////////////////////////////////////////////////////////

// : 
// : 02 ( 27.11.97 )
// : 
// :   2    .    
//   .

global ConvFtoU32 :label;


extern LShift32         :label;
extern RShift32         :label;
extern FFrExp           :label;
extern FPIEEE_Signal    :label;


import FPIEEE_FLAGS_DEF from rtmacro;

FPIEEE_FLAGS_DEF();


begin text

//=====  ConvFtoI32 ==========================
//       32 
//       32 
//  : gr7 -  float  32 
//  : gr7 -  ,   32 
// : ar5
<ConvFtoU32>
    push ar0, gr0
        with gr7;
    push ar1, gr1;
    if < skip Abnormal;
    push ar7, gr7;
    call FFrExp;
    gr7 = 127 + 23;
    if <>0 delayed skip Abnormal;
    pop ar0, gr0;
    with gr0 -= gr7;
    // cond. skip Abnormal
    if >= skip Large;

        //    RShift32
    delayed call RShift32;
    with gr0 = -gr0;
    push ar0, gr0;
    // call RShift32;

    skip Res;
    // skip Res;

<Large>
    gr7 = 9;
    with gr0 - gr7;
    if u>= skip Abnormal;

        //     LShift32
    delayed call LShift32;
    push ar0,gr0;
    nul;
    // call LShift32

<Res>
    pop ar1, gr1;
    pop ar0, gr0;
    return;

<Abnormal>
    delayed call FPIEEE_Signal;
    gr7 = _FPIEEE_Invalid;
    // call FPIEEE_Signal;
    pop ar1, gr1;
    pop ar0, gr0;
    return
        with gr7 = false;

end text;

//////////////////////////////////////////////////////////////////////////////
//                                                                          //
//                        ftou32.asm                              //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////
