extern cstb256: word;
extern freq1:   word;
global _fft256: label;
weak __main:    label;

nobits "bssdata1"
     global _Result: word[512];  //  
end "bssdata1";

nobits "bssdata"
    u_buf: word[1024];  //    U 
end "bssdata";

data "data1"
    matr1: word[64] = ( 0,0,1,0,  0,0, 0, 1,
                        0,0,0,1,  0,0,-1, 0,
                        0,0,1,0,  0,0, 0, 1,
                        0,0,0,1,  0,0,-1, 0,
                        0,0,1,0,  0,0, 0, 1,
                        0,0,0,1,  0,0,-1, 0,
                        0,0,1,0,  0,0, 0, 1,
                        0,0,0,1,  0,0,-1, 0);

    matr2: word[64] = ( 0,0,1,0,  0,0, 0, 1,
                        0,0,0,1,  0,0,-1, 0,
                        0,0,1,0,  0,0, 0, 1,
                        0,0,0,1,  0,0,-1, 0,
                        0,0,1,0,  0,0, 0, 1,
                        0,0,0,1,  0,0,-1, 0,
                        0,0,1,0,  0,0, 0, 1,
                        0,0,0,1,  0,0,-1, 0);
end "data1";

macro WTW()
.wait;
    nb1 = gr7;
    wtw;
.branch;

end WTW;
//    256  
//
//  16p+q    16q+p.
// 1 :  
// 2 :  32 
// 3 :     1024 32 
// 4 :  4
// $100,128,$80001000,$80000000       :
//      1962 (16   8*8)
//        866
//   4366
begin "text"
<_fft256>
<__main>
.wait;
    push ar0, gr0;
    push ar1, gr1;
    push ar2, gr2;
    push ar3, gr3;
    push ar4, gr4;
    push ar5, gr5;
    push ar6, gr6;
    pswr set 00030000h;
    pswr clear 00030000h;
    t1 = 0;
    gr0 = 1;
<AAA>
    push ar0, gr0;
    call fft16x16;
    pop ar0, gr0;
    gr0--;
    if > goto AAA;
    gr7 = t1;
    pop ar6, gr6;
    pop ar5, gr5;
    pop ar4, gr4;
    pop ar3, gr3;
    pop ar2, gr2;
    pop ar1, gr1;
    pop ar0, gr0;
    return;

<fft16x16>
.branch;
     pswr set 00030000h;

     gr7 = 80000000h;   // 2  32   Y
     sb  = 3030303h;    // 8  8    X
     ar4 = freq1;       //  
     gr4 = 32;
     nb1 = gr7;
     gr1 = ar4 with gr2 = gr4 >> 4;
     rep 16 wfifo = [ar4++gr4], ftw;
     WTW(); // Local

     gr5 = cstb256; //  .
     ar6 = u_buf with gr1 += gr2;   //   1024 32.
     ar0 = gr5;                     //   .
     ar4 = gr1 with gr1 += gr2;
.repeat 15;
     rep 32 data = [ar0++],ftw with vsum , data, 0; // Global bus
     rep 16 wfifo = [ar4++gr4];                     // Local bus
     WTW();
     ar4 = gr1 with gr1 += gr2;
     rep 32 data = [ar0++],ftw with vsum , data, afifo; // Global bus
     WTW();
     rep 32 [ar6++] = afifo;                           // Local
.endrepeat;
     rep 32 data = [ar0++],ftw with vsum , data, 0; // 15
     WTW();
     rep 32 data = [ar0++] with vsum , data, afifo;
     sb  = 00000c03h;
     ar0 = matr1;
     rep 32 wfifo = [ar0++],ftw;
     WTW();
     rep 32 [ar6++] = afifo;

//     re*re-im*im, re*im+im*re
     ar3 = u_buf;     //    = 2
     gr3 = 4;
     ar1 = ar3 + 2 with gr1=gr3;
     ar4 = _Result;
.repeat 3;
     rep 32 data = [ar3++gr3],ftw with vsum , data, 0;
     WTW();
     rep 32 data = [ar1++gr1],ftw with vsum ,data,afifo;
     WTW();
     rep 32 [ar4++] = afifo;
.endrepeat;
     rep 32 data = [ar3++gr3],ftw with vsum ,data,0;
     WTW();
     rep 32 data = [ar1++gr1] with vsum ,data,afifo;

     ar0 = matr1;
     rep 32 wfifo = [ar0++],ftw;
     WTW();
     rep 32 [ar4++] = afifo;

.repeat 3;
     rep 32 data = [ar3++gr3],ftw with vsum , data, 0;
     WTW();
     rep 32 data = [ar1++gr1],ftw with vsum ,data,afifo;
     WTW();
     rep 32 [ar4++] = afifo;
.endrepeat;
     rep 32 data = [ar3++gr3],ftw with vsum ,data,0;
     WTW();
     rep 32 data = [ar1++gr1] with vsum ,data,afifo;

     sb  = 3030303h;    // 8  8    X
     ar3 = _Result with gr3 = gr4;       //  

     gr1 = ar3;
     rep 16 wfifo = [ar3++gr3], ftw;
     WTW(); // Local
     rep 32 [ar4++] = afifo;

     ar6 = u_buf with gr1 += gr2;   //   1024 32.
     ar0 = gr5;
     ar4 = gr1 with gr1 += gr2;
.repeat 15;
     rep 32 data = [ar0++],ftw with vsum , data, 0; // 0-14 // Global
     rep 16 wfifo = [ar4++gr4];  //Local
     ar4 = gr1 with gr1 += gr2;
     WTW();
     rep 32 data = [ar0++],ftw with vsum , data, afifo; // Global
     WTW();
     ar0 = gr5;
     rep 32 [ar6++] = afifo; // Local
.endrepeat;
     rep 32 data = [ar0++],ftw with vsum , data, 0; // 15
     WTW();
     rep 32 data = [ar0++] with vsum , data, afifo;
     sb  = 00000c03h;
     ar0 = matr2;
     rep 32 wfifo = [ar0++],ftw;
     WTW();
     rep 32 [ar6++] = afifo;

 //     re*re-im*im, re*im+im*re
     gr3 = 4;
     ar3 = u_buf;     //   =2
     ar1 = u_buf + 2 with gr1=gr3;
     ar4 = _Result;

.repeat 3;
     rep 32 data = [ar3++gr3],ftw with vsum ,data,0;
     WTW();
     rep 32 data = [ar1++gr1],ftw with vsum ,data,afifo;
     rep 32 [ar4++] = afifo;
     WTW();
.endrepeat;
     rep 32 data = [ar3++gr3],ftw with vsum ,data,0;
     WTW();
     rep 32 data = [ar1++gr1] with vsum ,data,afifo;

     ar0 = matr2;
     rep 32 wfifo = [ar0++],ftw;
     WTW();
     rep 32 [ar4++] = afifo;

.repeat 3;
     rep 32 data = [ar3++gr3],ftw with vsum ,data,0;
     WTW();
     rep 32 data = [ar1++gr1],ftw with vsum ,data,afifo;
     rep 32 [ar4++] = afifo;
     WTW();
.endrepeat;
     rep 32 data = [ar3++gr3],ftw with vsum ,data,0;
     WTW();
     rep 32 data = [ar1++gr1] with vsum ,data,afifo;
     rep 32 [ar4++] = afifo;
    pswr clear 00030000h;

    return;
.wait;
end "text";
