//----------------------------------------------------------------
//
// Copyright 1998-2010 (c) RC Module.
// NeuroChip NM6405.
//
// int05.asm
// 
//      
//
//----------------------------------------------------------------

import from macros6405;

global _LibintIntManager : label;
global _DefaultIntHandler : label;
global _EnableInterrupts : label;
global _DisableInterrupts : label;
global _Inter_Template : label;
global _FlushInterrupts05 : label;

extern _LibintIntHandlers : word;

data ".data"



end ".data";


begin ".text"

<_Inter_Template>
   pswr_nmc3 clear 0000_01e0h;  // 0,1   
   push ar5, gr5;               // 2    ar5 - callee saved
   gr5 = pc;                    // 3    
   delayed goto _LibintIntManager;   //  4,5
   push gr6;                    // 6    gr6 -  callee saved
   push gr7;                    // 7    gr7 - callee saved

<_DefaultIntHandler>
	return;

<_LibintIntManager>
	ar5 = _LibintIntHandlers with gr5 = gr5 >> 3;
	gr7 = [ar5+gr5];
	call gr7;
.align;
	pop gr7;		//	push-  
	pop gr6;
	pop ar5, gr5;
	ireturn;

//	 ,   ,
//	   PSWR,   IMR
//	    
//	  pswr,     .

<_EnableInterrupts>

	gr7 = [ar7-3];

//	push gr0,ar0;
//	gr0 = 0000_01e0h;
//	gr7 = gr7 and gr0;
//	pop gr0,ar0;

	pswr_nmc3 set gr7;
	gr7 = [ar7-4];
	PR_05_GUARD( imr set gr7 );
	return;

<_DisableInterrupts>

	gr7 = [ar7-3];

//	push gr0,ar0;
//	gr0 = 0000_01e0h;
//	gr7 = gr7 and gr0;
//	pop gr0,ar0;

	pswr_nmc3 clear gr7;
	gr7 = [ar7-4];
	PR_05_GUARD( imr clear gr7 );
	return;

<_FlushInterrupts05>

	delayed return;
	vnul;
	intr_nmc3 clear 3c0h;

	
end ".text";
