//----------------------------------------------------------------
//
// NeuroChip NM6403, C runtime library
// 1997-1999 (c) RC Module Inc.
// wcstombs.c,
//
//----------------------------------------------------------------

#include <stdlib.h>

#ifdef __cplusplus
extern "C"
#endif
size_t wcstombs (char *s, const wchar_t *pwcs, size_t n)
{
	int i;

	for (i=0; i<n && *pwcs; i++)
		*s++ = *pwcs++;

	if (i<n)
		*s = 0;

	// sizeof(char) may be different in C and C++
	return sizeof(char)*i;
}
